// set up a simple neutral simulation
initialize() {
	defineConstant("simID", getSeed());
	initializeMutationRate(1e-7);
	
	// m1 mutation type: neutral
	initializeMutationType("m1", 0.5, "f", 0.0);
	
	//m2 mutation type: sweep mutation, fully dominant (1.0) and fixed ("f") DFE with selection coefficient 0.5 (strongly beneficial mutation), hence less likely to be lost due to drift when it is at low frequency
	initializeMutationType("m2", 0.5, "f", 0.01);
	
	// g1 genomic element type: uses m1 for all mutations
	initializeGenomicElementType("g1", m1, 1.0);
	
	// uniform chromosome of length 100 kb with uniform recombination
	initializeGenomicElement(g1, 0, 99999);
	initializeRecombinationRate(1e-8);
}

// create a population of 500 individuals
1 {
	sim.addSubpop("p1", 500);
}
//introduction of beneficial mutation that can be swept
1000 late(){
	target = sample(p1.genomes, 1); //draws 1 sample from p1 genomes
	target.addNewDrawnMutation(m2, 10000); //adds mutation of m2 (beneficial) at 10000 bp
	sim.outputFull("/tmp/slim_" + simID + ".txt");
}
//tracking the beneficial mutation
1000:100000 late() {
	sweep = sim.mutationsOfType(m2);
	if (size(sweep) == 0)
	{
		if (any(sim.substitutions.mutationType == m2))
		{
			cat(simID + ": FIXED\n");
			sim.simulationFinished();
		}
		else
		{
			cat(simID + ": LOST - RESTARTING\n");
			sim.readFromPopulationFile("/tmp/slim_" + simID + ".txt");
			setSeed(rdunif(1, 0, asInteger(2^62) - 1));
			catn("# NEW SEED: " + getSeed());
		
		}
	}
	else
	{
		freq = sim.mutationFrequencies(NULL, sweep);
		catn(sim.generation + ": " + freq);
	}
}



100000 late(){
	catn("TIME EXPIRED");
	sim.simulationFinished();
}
